Qore Programming Language Reference Manual: Qore::HTTPClient Class Reference

Qore Programming Language Reference Manual 0.8.11

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | List of all members
Qore::HTTPClient Class Reference

The HTTPClient class can be used to communicate with HTTP servers with and without TLS/SSL encryption. More...

Inheritance diagram for Qore::HTTPClient:
[legend]

## Public Member Functions
nothing | clearProxyURL ()
| Clears the new proxy URL value for the next connection. More...
nothing | clearProxyUserPassword ()
| Clears the username and password for the next proxy connection. More...
| clearStats ()
| Clears performance statistics. More...
nothing | clearUserPassword ()
| Clears the username and password for the connection. More...
nothing | clearWarningQueue ()
| Removes any warning Queue object from the Socket. More...
nothing | connect ()
| Connects to the remote socket; SSL/TLS negotiation is performed if required. More...
| constructor (hash opts)
| Creates the HTTPClient object based on the option parameter passed. More...
| constructor ()
| Creates the HTTPClient object. More...
| copy ()
| Copying objects of this class is not supported, an exception will be thrown. More...
| destructor ()
| Destroys the HTTPClient object and closes any open connections. More...
nothing | disconnect ()
| Disconnects from the remote socket if a connection is established (otherwise does nothing) More...
*string | get (string path, *hash headers, *reference info)
| Sends an HTTP `GET` request and returns the message body received as a string or NOTHING if no message body is received. More...
int | getConnectTimeout ()
| Returns the connect timeout as an integer in milliseconds. More...
*string | getConnectionPath ()
| Returns the current connection path set in the URL. More...
string | getDefaultPath ()
| Returns the default path used by the object if no path is set in the URL. More...
string | getEncoding ()
| Returns the character encoding used for the object. More...
string | getHTTPVersion ()
| Returns the HTTP protocol version string used in outgoing messages. More...
int | getMaxRedirects ()
| Returns the current `max_redirects` value for the object (the maximum number of HTTP redirects that will be processed before an exception is raised) More...
bool | getNoDelay ()
| Returns the `TCP_NODELAY` setting for the HTTPClient object. More...
*string | getProxyURL ()
| Returns the current proxy URL as a string or NOTHING if no proxy URL is set. More...
int | getTimeout ()
| Returns the default I/O timeout as an integer in milliseconds. More...
*string | getURL ()
| Returns the current URL. More...
hash | getUsageInfo ()
| Returns performance statistics for the socket. More...
hash | head (string path, *hash headers, *reference info)
| Sends an HTTP `HEAD` request and returns as hash of the headers received. More...
bool | isConnected ()
| Returns True or False giving the current connection state. More...
bool | isProxySecure ()
| Returns the SSL/TLS flag for the next proxy connection. More...
bool | isSecure ()
| Returns True if the current connection is encrypted, False if not. More...
*string | post (string path, string body, *hash headers, *reference info)
| Sends an HTTP `POST` request with a message body and returns the message body received as a string or NOTHING if no message body is received. More...
*string | post (string path, *binary body, *hash headers, *reference info)
| Sends an HTTP `POST` request with a message body and returns the message body received as a string or NOTHING if no message body is received. More...
hash | send (string body, string method, *string path, *hash headers, softbool getbody=False, *reference info)
| Sends an HTTP request with the specified method and optional message body and returns headers and any body received as a response in a hash format. More...
hash | send (*binary body, string method, *string path, *hash headers, softbool getbody=False, *reference info)
| Sends an HTTP request with the specified method and optional message body and returns headers and any body received as a response in a hash format. More...
nothing | sendWithCallbacks (code scb, code rcb, string method, *string path, *hash headers, timeout timeout_ms=0, softbool getbody=False, *reference info)
| Sends an HTTP request with the specified method and chunked message body as given by a send callback; headers and any body received are returned through a receive callback. More...
nothing | sendWithRecvCallback (code rcb, string body, string method, *string path, *hash headers, timeout timeout_ms=0, softbool getbody=False, *reference info)
| Sends an HTTP request with the specified method and optional message body; headers and any body received are returned through a receive callback. More...
nothing | sendWithRecvCallback (code rcb, *binary body, string method, *string path, *hash headers, timeout timeout_ms=0, softbool getbody=False, *reference info)
| Sends an HTTP request with the specified method and optional message body; headers and any body received are returned through a receive callback. More...
hash | sendWithSendCallback (code scb, string method, *string path, *hash headers, timeout timeout_ms=0, softbool getbody=False, *reference info)
| Sends an HTTP request with the specified method and chunked message body as given by a send callback and returns headers and any body received as a response in a hash format. More...
nothing | setConnectTimeout (timeout timeout_ms=-1)
| Sets the connect timeout in milliseconds. More...
nothing | setDefaultPath (*string path)
| Sets the default path used by the object if no path is set in the URL. More...
nothing | setEncoding (string encoding)
| Sets the string encoding for the object; any strings deserialized with this object will be tagged with this character encoding. More...
nothing | setEventQueue ()
| Clears any Queue object that may be set on the HTTPClient object so that I/O events are no longer captured on the object. More...
nothing | setEventQueue (Qore::Thread::Queue queue)
| Sets a Queue object to receive HTTPClient and Socket events. More...
nothing | setHTTPVersion (string ver)
| Sets the HTTP protocol version string for headers in outgoing messages, allowed values are `"1.0"` and "1.1". More...
nothing | setMaxRedirects (softint mr=0)
| Updates the setting for the `max_redirects` value for the object (maximum number of HTTP redirects that will be processed before an exception is raised) More...
int | setNoDelay (softbool b=True)
| Sets the `TCP_NODELAY` setting for the object. More...
| setPersistent ()
| temporarily disables implicit reconnections; must be called when the server is already connected More...
nothing | setProxySecure (softbool b=True)
| Sets the SSL/TLS flag for the next connection to the proxy. More...
nothing | setProxyURL ()
| Clears the new proxy URL value for the next connection. More...
nothing | setProxyURL (string url)
| Sets a new proxy URL value for the next connection. More...
nothing | setProxyUserPassword (string user, string pass)
| Sets the username and password for the connection to the proxy; call after HTTPClient::setProxyURL() More...
nothing | setProxyUserPassword ()
| Clears the username and password for the next proxy connection. More...
nothing | setSecure (softbool secure=True)
| Sets the object to make a secure SSL/TLS connection on the next connect if the passed argument is True, or an unencrypted cleartext connection if it is False. More...
nothing | setTimeout (timeout timeout_ms=0)
| Sets the default I/O timeout value in milliseconds. More...
| setURL (string url)
| Sets a new URL value for the next connection. More...
nothing | setUserPassword (string user, string pass)
| Sets the username and password for the connection; call after HTTPClient::setURL() More...
nothing | setUserPassword ()
| Clears the username and password for the connection. More...
nothing | setWarningQueue (int warning_ms, int warning_bs, Queue queue, any arg, timeout min_ms=1s)
| Sets a Queue object to receive socket warnings. More...
Public Member Functions inherited from Qore::Socket
Socket | accept ()
| Accepts connections on a listening socket. More...
*Socket | accept (timeout timeout_ms)
| Accepts connections on a listening socket (see Socket::listen()) accepting a timeout value with a millisecond resolution. More...
Socket | acceptSSL ()
| Accepts connections on a listening socket and attempts to negotiate a TLS/SSL connection. More...
*Socket | acceptSSL (timeout timeout_ms)
| Accepts connections on a listening socket and attempts to negotiate a TLS/SSL connection accepting a timeout value with a millisecond resolution. More...
int | bind (string str, softbool reuseaddr=False)
| Opens and binds the socket to a port, interface and port (if the $bind_to string has a format "host:port"), or UNIX domain socket file. More...
int | bind (int port, softbool reuseaddr=False)
| Opens and binds the socket to an INET port on all interfaces. More...
nothing | bindINET (*string iface, *softstring service, softbool reuseaddr=False, softint family=AF_UNSPEC, softint socktype=SOCK_STREAM, softint protocol=0)
| Opens and binds the socket to the given IPv4 or IPv6 interface (or if no interface is given, then to all interfaces on the local system) and port (the port number will be derived from the service name if a numeric port number is not given) More...
nothing | bindUNIX (string path, softint socktype=SOCK_STREAM, softint protocol=0)
| Opens and binds the socket to the given UNIX domain socket file as given by the filename argument. If any errors occur, an exception is thrown. More...
| clearStats ()
| Clears performance statistics. More...
nothing | clearWarningQueue ()
| Removes any warning Queue object from the Socket. More...
int | close ()
| Closes an open socket. More...
nothing | connect (string target, timeout timeout_ms=-1)
| Connects to a remote port (if the string has a format "host:port") or UNIX domain socket file with an optional timeout value with a millisecond resolution. More...
nothing | connectINET (string host, softstring service, timeout timeout_ms=-1, softint family=AF_UNSPEC, softint socktype=SOCK_STREAM, softint protocol=0)
| Connects to the given host and port with an optional timeout value with a millisecond resolution. More...
nothing | connectINETSSL (string host, softstring service, timeout timeout_ms=-1, softint family=AF_UNSPEC, softint socktype=SOCK_STREAM, softint protocol=0)
| Connects to the given host and port and attempts to establish a TLS/SSL connection; accepts an optional timeout value with a millisecond resolution. More...
nothing | connectSSL (string target, timeout timeout_ms=-1)
| Connects to a remote socket and attempts to establish a TLS/SSL connection; accepts an optional timeout value with a millisecond resolution. More...
nothing | connectUNIX (string path, softint socktype=SOCK_STREAM, softint protocol=0)
| Connects to a UNIX domain socket file. More...
nothing | connectUNIXSSL (string path, softint socktype=SOCK_STREAM, softint protocol=0)
| Connects to the given UNIX domain socket file and attempts to establish a TLS/SSL connection. More...
| constructor ()
| Creates the socket object. More...
| copy ()
| Creates a new Socket object, not based on the source being copied. More...
string | getCharset ()
| Returns the character encoding for the socket. More...
string | getEncoding ()
| Returns the character encoding for the socket. More...
bool | getNoDelay ()
| Returns the `TCP_NODELAY` setting for the socket. More...
hash | getPeerInfo (bool host_lookup=True)
| Returns a hash of information about the remote end for connected sockets. More...
int | getPort ()
| Returns the port number of the socket for INET sockets. More...
int | getRecvTimeout ()
| Returns the receive timeout socket option value as an integer in milliseconds. More...
*string | getSSLCipherName ()
| Returns the name of the cipher for an encrypted connection or NOTHING if a secure connection has not been established. More...
*string | getSSLCipherVersion ()
| Returns the version string of the cipher for an encrypted connection or NOTHING if a secure connection has not been established. More...
int | getSendTimeout ()
| Returns the send timeout socket option value as an integer in milliseconds. More...
int | getSocket ()
| Returns the socket file descriptor number. More...
hash | getSocketInfo (bool host_lookup=True)
| Returns information about the local socket as a hash. More...
hash | getUsageInfo ()
| Returns performance statistics for the socket. More...
bool | isDataAvailable (timeout timeout_ms=0)
| Returns True or False depending on whether there is data to be read on the socket. More...
bool | isOpen ()
| Returns True if the socket is open. More...
bool | isSecure ()
| Returns True if the connection is a secure TLS/SSL connection. More...
bool | isWriteFinished (timeout timeout_ms=0)
| Returns True or False depending on whether all the data has been written to the socket. More...
int | listen (int backlog=20)
| Listens for connections on a bound socket; sets the socket in a listening state. More...
bool | pendingHttpChunkedBody ()
| returns True if the socket is still connected, and a HTTP header was read indicating chunked transfer encoding, but no chunked body has been read yet More...
hash | readHTTPChunkedBody (timeout timeout_ms=-1)
| Reads in an HTTP message body sent in chunked transfer encoding and returns it with any footers received as a string in the `"body"` key of a hash (including footers received) More...
hash | readHTTPChunkedBodyBinary (timeout timeout_ms=-1)
| Reads in an HTTP message body sent in chunked transfer encoding and returns it with any footers received as a binary object in the `"body"` key of a hash (including footers received) More...
| readHTTPChunkedBodyBinaryWithCallback (code rcb, timeout timeout_ms=-1)
| Reads in an HTTP message body sent in chunked transfer encoding and returns it with any footers received as a string in the `"body"` key of a hash (including footers received) More...
| readHTTPChunkedBodyWithCallback (code rcb, timeout timeout_ms=-1)
| Reads in an HTTP message body sent in chunked transfer encoding and returns it with any footers received as a string in the `"body"` key of a hash (including footers received) More...
hash | readHTTPHeader (timeout timeout_ms=-1, *reference info)
| Retuns a hash representing the data in the HTTP header read, or, if the data cannot be parsed as an HTTP header, then an exception is thrown, and the data read is returned as a string in the `arg` key of the exception hash. More...
string | readHTTPHeaderString (timeout timeout_ms=-1)
| Retuns a string representing the data in the HTTP header read (reads until `"\r\n\r\n"`) More...
string | recv (softint size=0, timeout timeout_ms=-1)
| Receives data from the socket and returns a string tagged with the Socket's character encoding. More...
binary | recvBinary (softint size=0, timeout timeout_ms=-1)
| Receives data from the socket and returns a binary object. More...
int | recvi1 (timeout timeout_ms=-1)
| Receives a 1-byte signed integer from the socket. More...
int | recvi2 (timeout timeout_ms=-1)
| Receives a 2-byte (16-bit) signed integer in big-endian format (network byte order) from the socket. More...
int | recvi2LSB (timeout timeout_ms=-1)
| Receives a 2-byte (16-bit) signed integer in little-endian format from the socket. More...
int | recvi4 (timeout timeout_ms=-1)
| Receives a 4-byte (32-bit) signed integer in big-endian format (network byte order) from the socket. More...
int | recvi4LSB (timeout timeout_ms=-1)
| Receives a 4-byte (32-bit) signed integer in little-endian format from the socket. More...
int | recvi8 (timeout timeout_ms=-1)
| Receives an 8-byte (64-bit) signed integer in big-endian format (network byte order) from the socket. More...
int | recvi8LSB (timeout timeout_ms=-1)
| Receives an 8-byte (64-bit) signed integer in little-endian format from the socket. More...
int | recvu1 (timeout timeout_ms=-1)
| Receives a 1-byte unsigned integer from the socket. More...
int | recvu2 (timeout timeout_ms=-1)
| Receives a 2-byte (16-bit) unsigned integer in big-endian format (network byte order) from the socket. More...
int | recvu2LSB (timeout timeout_ms=-1)
| Receives a 2-byte (16-bit) unsigned integer in little-endian format from the socket. More...
int | recvu4 (timeout timeout_ms=-1)
| Receives a 4-byte (32-bit) unsigned integer in big-endian format (network byte order) from the socket. More...
int | recvu4LSB (timeout timeout_ms=-1)
| Receives a 4-byte (32-bit) unsigned integer in little-endian format from the socket. More...
int | send (binary bin, int timeout_ms=-1)
| Sends binary data over the socket; if any errors occur, an exception is thrown. More...
int | send (string str, timeout timeout_ms=-1)
| Sends string data over the socket; string data is converted to the socket's encoding if necessary; if any errors occur, an exception is thrown. More...
nothing | send2 (binary bin, timeout timeout_ms=-1)
| Sends binary data over the socket; if any errors occur, an exception is thrown. More...
nothing | send2 (string str, timeout timeout_ms=-1)
| Sends string data over the socket; string data is converted to the socket's encoding if necessary; if any errors occur, an exception is thrown. More...
int | sendBinary (string str, timeout timeout_ms=-1)
| Sends string data over the socket without converting the string to the socket's encoding, but instead is sent exactly as-is; if any errors occur, an exception is thrown. More...
int | sendBinary (binary bin, timeout timeout_ms=-1)
| Sends binary data over the socket; if any errors occur, an exception is thrown. More...
nothing | sendBinary2 (string str, timeout timeout_ms=-1)
| Sends string data over the socket without converting the string to the socket's encoding, but instead is sent exactly as-is; if any errors occur, an exception is thrown. More...
nothing | sendBinary2 (binary bin, timeout timeout_ms=-1)
| Sends binary data over the socket; if any errors occur, an exception is thrown. More...
nothing | sendHTTPMessage (string method, string path, string http_version, hash headers, *string body, *reference info, timeout timeout_ms=-1)
| Sends an HTTP message with a method and user-defined headers given as a hash and an optional message body. More...
nothing | sendHTTPMessage (string method, string path, string http_version, hash headers, binary body, *reference info, timeout timeout_ms=-1)
| Sends an HTTP message with a method and user-defined headers given as a hash and an optional message body. More...
nothing | sendHTTPMessageWithCallback (code scb, string method, string path, string http_version, hash headers, *reference info, timeout timeout_ms=-1)
| Sends an HTTP message with a method and user-defined headers given as a hash and an optional message body. More...
nothing | sendHTTPResponse (softint status_code, string status_desc, string http_version, hash headers, *string body, timeout timeout_ms=-1)
| Sends an HTTP response with user-defined headers given as a hash and an optional message body. More...
nothing | sendHTTPResponse (softint status_code, string status_desc, string http_version, hash headers, binary body, timeout timeout_ms=-1)
| Sends an HTTP response with user-defined headers given as a hash and a message body as literal binary data. More...
nothing | sendHTTPResponseWithCallback (code scb, softint status_code, string status_desc, string http_version, hash headers, timeout timeout_ms=-1)
| Sends an HTTP response with user-defined headers given as a hash and a message body as literal binary data. More...
int | sendi1 (softint i=0, timeout timeout_ms=-1)
| Sends a 1-byte integer over the socket. More...
int | sendi2 (softint i=0, timeout timeout_ms=-1)
| Sends a 2-byte (16-bit) integer in big-endian format (network byte order) over the socket. More...
int | sendi2LSB (softint i=0, timeout timeout_ms=-1)
| Sends a 2-byte (16-bit) integer in little-endian format over the socket. More...
int | sendi4 (softint i=0, timeout timeout_ms=-1)
| Sends a 4-byte (32-bit) integer in big-endian format (network byte order) over the socket. More...
int | sendi4LSB (softint i=0, timeout timeout_ms=-1)
| Sends a 4-byte (32-bit) integer in little-endian format over the socket. More...
int | sendi8 (softint i=0, timeout timeout_ms=-1)
| Sends an 8-byte (64-bit) integer in big-endian format (network byte order) over the socket. More...
int | sendi8LSB (softint i=0, timeout timeout_ms=-1)
| Sends an 8-byte (64-bit) integer in little-endian format over the socket. More...
nothing | setCertificate (SSLCertificate cert)
| Sets the X.509 certificate to use for negotiating encrypted connections. More...
nothing | setCertificate (string cert_pem)
| Sets the X.509 certificate to use for negotiating encrypted connections from the PEM-encoded string representing the X.509 certificate. More...
nothing | setCertificate (binary cert_der)
| Sets the X.509 certificate to use for negotiating encrypted connections from the DER-encoded binary object representing the X.509 certificate. More...
nothing | setCharset (string encoding)
| Sets the character encoding for the socket. More...
nothing | setEncoding (string encoding)
| Sets the character encoding for the socket. More...
nothing | setEventQueue ()
| Removes any Queue object from the Socket object so that socket events are no longer added to the Queue. More...
nothing | setEventQueue (Queue queue)
| Sets a Queue object to receive socket events. More...
int | setNoDelay (bool nd=True)
| Sets the boolean `TCP_NODELAY` setting for the socket. More...
nothing | setPrivateKey (SSLPrivateKey key)
| Sets the private key to use for negotiating encrypted connections along with the X.509 certificate. More...
nothing | setPrivateKey (string key_pem, *string pass)
| Sets the private key to use for negotiating encrypted connections along with the X.509 certificate from a PEM-encoded string representing the private key and an optional password. More...
nothing | setPrivateKey (binary key_der)
| Sets the private key to use for negotiating encrypted connections along with the X.509 certificate from a DER-encoded binary object representing the private key. More...
int | setRecvTimeout (timeout timeout_ms)
| sets the receive timeout as a socket option More...
int | setSendTimeout (timeout timeout_ms)
| sets the send timeout as a socket option More...
nothing | setWarningQueue (int warning_ms, int warning_bs, Queue queue, any arg, timeout min_ms=1s)
| Sets a Queue object to receive socket warnings. More...
int | shutdown ()
| Ensures that a socket will be closed even if the file descriptor is shared with other processes (for example, after a call to fork()) More...
nothing | shutdownSSL ()
| Shuts down the SSL connection on a secure connection. More...
nothing | upgradeClientToSSL ()
| Upgrades a client socket connection to a TLS/SSL connection. More...
nothing | upgradeServerToSSL ()
| Upgrades a server socket connection to a TLS/SSL connection. More...
*string | verifyPeerCertificate ()
| Returns a string code giving the result of verifying the remote certificate or NOTHING if an encrypted connection is not currently established. More...

## Detailed Description

The HTTPClient class can be used to communicate with HTTP servers with and without TLS/SSL encryption.

Restrictions:
  Qore::PO_NO_NETWORK

The HTTPClient class can be used to communicate with HTTP servers using the HTTP or HTTPS (HTTP using an SSL/TLS encrypted connection) protocol.

By default `"Connection: Keep-Alive"` is always sent regardless of the HTTP protocol level set for the object, however if a server response contains `"Connection: close"`, the connection will be closed as soon as the full response (including any message body if present) has been read.

HTTP redirect responses are supported and can be limited with the `max_redirects` constructor hash key or by using the HTTPClient::setMaxRedirects() method. The default maximum number of redirects allowed is 5.

HTTP basic authentication is supported; set the username and password in the URL (ex: `"http://username:password@host:port/path"`). To change the URL from the one set by the constructor, call HTTPClient::setURL().

HTTP proxies and basic proxy authentication are supported by setting the proxy constructor hash key to the proxy URL (with a proxy username and password if required) or by calling the HTTPClient::setProxyURL() method.

Objects of this class are thread-safe and support serializing multiple simultaneous requests from many threads. If a request is in progress and another thread attempts to make a request at the same time, the second thread will block until the first is complete. Therefore the total amount of time a thread could wait for a response in a multi-threaded context could be greater than the timeout value (which applies to the maximum time a single internal send() or recv() action can take).

This class understands and automatically decodes `"deflate"`, `"gzip"`, and `"bzip2"` content encodings as well.

The default I/O timeout value is 300,000 milliseconds (5 minutes). Note that the timeout value applies to individual internal send() or recv() operations; for this reason for large transfers the overall I/O time could exceed the timeout value.

When an exception is thrown (for example, a response code of < `100` or >= `400` is received from the server), any message body returned will be in the `"arg"` key of the exception hash.

This class understands the protocols in the following table.
HTTPClient Class Protocols

Protocol/Scheme | Default Port | SSL? | Description
`http` | `80` | No | Unencrypted HTTP protocol
`https` | `443` | Yes | HTTP protocol with SSL/TLS encryption

Whenever using an HTTPClient method where a hash of headers can be passed to the method, some headers are generated by default by the class and can be overridden, and some are cannot be overridden and are ignored if passed by the client. See the following tables for details.

HTTPClient Mandatory Headers

Header | Description
`Content-Length` | This header is only sent if a message body is sent, and, if so, the length is calculated automatically.

HTTPClient Default, but Overridable Headers

Header | Default Value
`Accept` | `"text/html"`
`Content-Type` | `"text/html"`
`User-Agent` | `"Qore-HTTP-Client/0.8.8"`
`Connection` | `"Keep-Alive"`
`Accept-Encoding` | `"deflate,gzip,bzip2"`

This class supports posting network events to a Queue. See I/O Event Handling for more information.

The events raised by this object are listed in the following table: HTTPClient Events

Name | Description
EVENT_HTTP_CONTENT_LENGTH | Raised when the HTTP `"Content-Length"` header is received.
EVENT_HTTP_CHUNKED_START | Raised when HTTP chunked data is about to be received.
EVENT_HTTP_CHUNKED_END | Raised when all HTTP chunked data has been received.
EVENT_HTTP_REDIRECT | Raised when an HTTP redirect message is received.
EVENT_HTTP_SEND_MESSAGE | Raised when an HTTP message is sent.
EVENT_HTTP_MESSAGE_RECEIVED | Raised when an HTTP message is received.
EVENT_HTTP_FOOTERS_RECEIVED | Raised when HTTP footers are received.
EVENT_HTTP_CHUNKED_DATA_RECEIVED | Raised when a block of HTTP chunked data is received.
EVENT_HTTP_CHUNK_SIZE | Raised when the next chunk size for HTTP chunked data is known.

Note
  - This class is not available with the PO_NO_NETWORK parse option.
  - URLs with UNIX sockets are generally supported in Qore with the following syntax: `scheme://socket=<url_encoded_path>/path`, where `url_encoded_path` is a path with URL-encoding as performed by encode_url(); for example: `"http://socket=%2ftmp%socket-dir%2fsocket-file-1/url/path"`; this allows a filesystem path to be used in the host portion of the URL and for the URL to include a URL path as well.

## Member Function Documentation

nothing Qore::HTTPClient::clearProxyURL | ( |  | ) |

Clears the new proxy URL value for the next connection.

Example:
  $httpclient.setProxyURL();

nothing Qore::HTTPClient::clearProxyUserPassword | ( |  | ) |

Clears the username and password for the next proxy connection.

Call this method after calling HTTPClient::setProxyURL() to clear any proxy authentication information present in the URL used in HTTPClient::setProxyURL()

Example:
  $httpclient.clearProxyUserPassword();

Qore::HTTPClient::clearStats | ( |  | ) |

Clears performance statistics.

Example:
  $httpclient.clearStats();

Since
  Qore 0.8.9

See Also
  HTTPClient::getUsageInfo()

nothing Qore::HTTPClient::clearUserPassword | ( |  | ) |

Clears the username and password for the connection.

Call this method after calling HTTPClient::setURL() to clear any authentication information present in the URL used in HTTPClient::setURL()

Example:
  $httpclient.clearUserPassword();

nothing Qore::HTTPClient::clearWarningQueue | ( |  | ) |

Removes any warning Queue object from the Socket.

Example:
  $httpclient.clearWarningQueue();

See Also
  HTTPClient::setWarningQueue()

Since
  Qore 0.8.9

nothing Qore::HTTPClient::connect | ( |  | ) |

Connects to the remote socket; SSL/TLS negotiation is performed if required.

If the protocol indicates that a secure connection should be established (or HTTPClient::setSecure() was called previsouly), SSL/TLS negotiation will be attempted.

If the `TCP_NODELAY` flag has been set (see HTTPClient::setNoDelay()), then after a successful connection to the remote socket, this option will be set on the socket. If an error occurs setting the `TCP_NODELAY` option, the internal flag is set to false (use HTTPClient::getNoDelay() to check the flag's state) and the error code can be retrieved with errno().

Example:
  $httpclient.connect();

Events:
  EVENT_CONNECTING, EVENT_CONNECTED, EVENT_HOSTNAME_LOOKUP, EVENT_HOSTNAME_RESOLVED, EVENT_START_SSL, EVENT_SSL_ESTABLISHED

Note
  For possible exceptions, see the Socket::connect() method (or Socket::connectSSL() for secure connections).

Qore::HTTPClient::constructor | ( | hash | opts | ) |

Creates the HTTPClient object based on the option parameter passed.

To connect, call any method that requires a connection and an implicit connection is established, or call HTTPClient::connect().

Example:
  my HTTPClient $httpclient(("url":"http://hostname:8080/path"));

Parameters

  opts | sets options and changes default behaviour for the object, etc; key names are case-sensitive and therefore must all be in lower-case: `url:` A string giving the URL to connect to `default_port:` The default port number to connect to if none is given in the URL `protocols:` A hash describing new protocols, the key is the protocol name and the value is either an integer giving the default port number or a hash with `"port"` and `"ssl"` keys giving the default port number and a boolean value to indicate that an SSL connection should be established `http_version:` Either `"1.0"` or `"1.1"` for the claimed HTTP protocol version compliancy in outgoing message headers `default_path:` The default path to use for new connections if a path is not otherwise specified in the connection URL `max_redirects:` The maximum number of redirects before throwing an exception (the default is 5) `proxy:` The proxy URL for connecting through a proxy `timeout:` The timeout value in milliseconds (also can be a relative date-time value for clarity, ex: `5m`) `connect_timeout:` The timeout value in milliseconds for establishing a new socket connection (also can be a relative date-time value for clarity, ex: `30s`)

Exceptions

  HTTP-CLIENT-OPTION-ERROR | invalid or unknown option passed in option hash
  HTTP-CLIENT-URL-ERROR | invalid URL string
  HTTP-CLIENT-UNKNOWN-PROTOCOL | unknown protocol passed in URL

Note
  URLs with UNIX sockets are generally supported in Qore with the following syntax: `scheme://socket=<url_encoded_path>/path`, where `url_encoded_path` is a path with URL-encoding as performed by encode_url(); for example: `"http://socket=%2ftmp%socket-dir%2fsocket-file-1/url/path"`; this allows a filesystem path to be used in the host portion of the URL and for the URL to include a URL path as well.

Qore::HTTPClient::constructor | ( |  | ) |

Creates the HTTPClient object.

Example:
  my HTTPClient $httpclient();

Qore::HTTPClient::copy | ( |  | ) |

Copying objects of this class is not supported, an exception will be thrown.

Exceptions

  HTTPCLIENT-COPY-ERROR | copying HTTPClient objects is not yet supported

Qore::HTTPClient::destructor | ( |  | ) |

Destroys the HTTPClient object and closes any open connections.

Example:
  delete $httpclient;

nothing Qore::HTTPClient::disconnect | ( |  | ) |

Disconnects from the remote socket if a connection is established (otherwise does nothing)

Example:
  $httpclient.disconnect();

*string Qore::HTTPClient::get | ( | string | path,
|  | *hash | headers,
|  | *reference | info
| ) |  |

Sends an HTTP `GET` request and returns the message body received as a string or NOTHING if no message body is received.

In order to get the headers and the body, use the HTTPClient::send() method instead.

If no connection has already been established, an internal call to HTTPClient::connect() will be made before sending the request.

If any content encoding is used for the message body in the reply, the content is decoded and returned as a string; if the content encoding uses an unknown method, then an exception is thrown.

Example:
  my *string $html = $httpclient.get("/path/file.html");

Parameters

  path | the path for the message (i.e. `"/path/resource?method&param=value"`)
  headers | an optional hash of headers to include in the message
  info | an optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request

Returns
  the message body in the reply to this message or NOTHING in case of an error or an erroneous reply by the server with no body

Events:
  EVENT_CONNECTING, EVENT_CONNECTED, EVENT_HOSTNAME_LOOKUP, EVENT_HOSTNAME_RESOLVED, EVENT_START_SSL, EVENT_SSL_ESTABLISHED, EVENT_HTTP_SEND_MESSAGE, EVENT_PACKET_SENT, EVENT_HTTP_MESSAGE_RECEIVED, EVENT_PACKET_READ, EVENT_HTTP_CONTENT_LENGTH, EVENT_HTTP_CHUNKED_START, EVENT_HTTP_CHUNKED_END, EVENT_HTTP_CHUNKED_DATA_RECEIVED, EVENT_HTTP_CHUNK_SIZE, EVENT_HTTP_FOOTERS_RECEIVED, EVENT_HTTP_REDIRECT

Exceptions

  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the return value of the send() method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

*string Qore::HTTPClient::getConnectionPath | ( |  | ) |

Returns the current connection path set in the URL.

Returns
  the current connection path set in the URL

Code Flags:
  CONSTANT

Example:
  my *string $path = $httpclient.getConnectionPath();

int Qore::HTTPClient::getConnectTimeout | ( |  | ) |

Returns the connect timeout as an integer in milliseconds.

Returns
  Returns the connect timeout as an integer in milliseconds; negative numbers mean the system default timeout is used

Code Flags:
  CONSTANT

Example:
  my int $to = $httpclient.getConnectTimeout();

string Qore::HTTPClient::getDefaultPath | ( |  | ) |

Returns the default path used by the object if no path is set in the URL.

Returns
  the default path used by the object if no path is set in the URL

Code Flags:
  CONSTANT

Example:
  my *string $def_path = $httpclient.getDefaultPath();

string Qore::HTTPClient::getEncoding | ( |  | ) |

Returns the character encoding used for the object.

Returns
  the character encoding used for the object

Code Flags:
  CONSTANT

Example:
  my string $encoding = $httpclient.getEncoding();

string Qore::HTTPClient::getHTTPVersion | ( |  | ) |

Returns the HTTP protocol version string used in outgoing messages.

Returns
  the HTTP protocol version string used in outgoing messages

Code Flags:
  CONSTANT

Example:
  my string $version = $httpclient.getHTTPVersion();

int Qore::HTTPClient::getMaxRedirects | ( |  | ) |

Returns the current `max_redirects` value for the object (the maximum number of HTTP redirects that will be processed before an exception is raised)

Returns
  the current `max_redirects` value for the object (the maximum number of HTTP redirects that will be processed before an exception is raised)

Code Flags:
  CONSTANT

Example:
  my int $mr = $httpclient.getMaxRedirects();

bool Qore::HTTPClient::getNoDelay | ( |  | ) |

Returns the `TCP_NODELAY` setting for the HTTPClient object.

Code Flags:
  CONSTANT

Example:
  my bool $b = $httpclient.getNoDelay();

See Also
  also HTTPClient::setNoDelay()

*string Qore::HTTPClient::getProxyURL | ( |  | ) |

Returns the current proxy URL as a string or NOTHING if no proxy URL is set.

Returns
  the current proxy URL as a string or NOTHING if no proxy URL is set

Code Flags:
  CONSTANT

Example:
  my *string $proxy_url = $httpclient.getProxyURL();

int Qore::HTTPClient::getTimeout | ( |  | ) |

Returns the default I/O timeout as an integer in milliseconds.

Returns
  the default I/O timeout as an integer in milliseconds; 0 means immediate timeout (when reading only returns data if it is already available), and negative numbers mean never timeout

Code Flags:
  CONSTANT

Example:
  my int $timeout = $httpclient.getTimeout();

*string Qore::HTTPClient::getURL | ( |  | ) |

Returns the current URL.

Returns
  the current URL

Code Flags:
  CONSTANT

Example:
  my *string $url = $httpclient.getURL();

hash Qore::HTTPClient::getUsageInfo | ( |  | ) |

Returns performance statistics for the socket.

Code Flags:
  CONSTANT

Example:
  my hash $h = $httpclient.getUsageInfo();

Returns
  a hash with the following keys:
  - `"bytes_sent"`: an integer giving the total amount of bytes sent
  - `"bytes_recv"`: an integer giving the total amount of bytes received
  - `"us_sent"`: an integer giving the total number of microseconds spent sending data
  - `"us_recv"`: an integer giving the total number of microseconds spent receiving data
  - `"arg"`: (only if warning values have been set with HTTPClient::setWarningQueue()) the optional argument for warning hashes
  - `"timeout"`: (only if warning values have been set with HTTPClient::setWarningQueue()) the warning timeout in microseconds
  - `"min_throughput"`: (only if warning values have been set with HTTPClient::setWarningQueue()) the minimum warning throughput in bytes/sec

Since
  Qore 0.8.9

See Also
  HTTPClient::clearStats()

hash Qore::HTTPClient::head | ( | string | path,
|  | *hash | headers,
|  | *reference | info
| ) |  |

Sends an HTTP `HEAD` request and returns as hash of the headers received.

If no connection is established, an internal call to HTTPClient::connect() will be made before sending the message.

Example:
  my hash $msg = $httpclient.head("/path");

Parameters

  path | the path for the message (i.e. `"/path/resource?method&param=value"`)
  headers | an optional hash of headers to include in the message
  info | an optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request

Returns
  the headers received from the HTTP server with all key names converted to lower-case

Events:
  EVENT_CONNECTING, EVENT_CONNECTED, EVENT_HOSTNAME_LOOKUP, EVENT_HOSTNAME_RESOLVED, EVENT_START_SSL, EVENT_SSL_ESTABLISHED, EVENT_HTTP_SEND_MESSAGE, EVENT_PACKET_SENT, EVENT_HTTP_MESSAGE_RECEIVED, EVENT_PACKET_READ, EVENT_HTTP_REDIRECT

Exceptions

  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the return value of the send() method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

bool Qore::HTTPClient::isConnected | ( |  | ) |

Returns True or False giving the current connection state.

Returns
  True or False giving the current connection state

Code Flags:
  CONSTANT

Example:
  my bool $b = $httpclient.isConnected();

bool Qore::HTTPClient::isProxySecure | ( |  | ) |

Returns the SSL/TLS flag for the next proxy connection.

Returns
  the SSL/TLS flag for the next proxy connection

Code Flags:
  CONSTANT

Example:
  my bool $b = $httpclient.isProxySecure();

bool Qore::HTTPClient::isSecure | ( |  | ) |

Returns True if the current connection is encrypted, False if not.

Returns
  True if the current connection is encrypted, False if not

Code Flags:
  CONSTANT

Example:
  if ($httpclient.isSecure())
  printf("secure connection: %s %s\n", $httpclient.getSSLCipherName(), $httpclient.getSSLCipherVersion());

*string Qore::HTTPClient::post | ( | string | path,
|  | string | body,
|  | *hash | headers,
|  | *reference | info
| ) |  |

Sends an HTTP `POST` request with a message body and returns the message body received as a string or NOTHING if no message body is received.

In order to get the headers and the body in the response, use the HTTPClient::send() method instead.

If no connection is established, an internal call to HTTPClient::connect() will be made before sending the message.

Example:
  $httpclient.post("/path", $body);

Parameters

  path | the path for the message (i.e. `"/path/resource?method&param=value"`)
  body | the string to use as the message body
  headers | an optional hash of headers to include in the message
  info | an optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request

Returns
  the message body in the reply to this message or NOTHING in case no body was present in the response

Events:
  EVENT_CONNECTING, EVENT_CONNECTED, EVENT_HOSTNAME_LOOKUP, EVENT_HOSTNAME_RESOLVED, EVENT_START_SSL, EVENT_SSL_ESTABLISHED, EVENT_HTTP_SEND_MESSAGE, EVENT_PACKET_SENT, EVENT_HTTP_MESSAGE_RECEIVED, EVENT_PACKET_READ, EVENT_HTTP_CONTENT_LENGTH, EVENT_HTTP_CHUNKED_START, EVENT_HTTP_CHUNKED_END, EVENT_HTTP_CHUNKED_DATA_RECEIVED, EVENT_HTTP_CHUNK_SIZE, EVENT_HTTP_FOOTERS_RECEIVED, EVENT_HTTP_REDIRECT

Exceptions

  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the return value of the send() method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  ENCODING-CONVERSION-ERROR | the given string could not be converted to the socket's character encoding
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

*string Qore::HTTPClient::post | ( | string | path,
|  | *binary | body,
|  | *hash | headers,
|  | *reference | info
| ) |  |

Sends an HTTP `POST` request with a message body and returns the message body received as a string or NOTHING if no message body is received.

In order to get the headers and the body in the response, use the HTTPClient::send() method instead.

If no connection is established, an internal call to HTTPClient::connect() will be made before sending the message.

Example:
  $httpclient.post("/path", $body);

Parameters

  path | the path for the message (i.e. `"/path/resource?method&param=value"`)
  body | the optional data to use as the message body
  headers | an optional hash of headers to include in the message
  info | an optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request

Returns
  the message body in the reply to this message or NOTHING in case no body was present in the response

Events:
  EVENT_CONNECTING, EVENT_CONNECTED, EVENT_HOSTNAME_LOOKUP, EVENT_HOSTNAME_RESOLVED, EVENT_START_SSL, EVENT_SSL_ESTABLISHED, EVENT_HTTP_SEND_MESSAGE, EVENT_PACKET_SENT, EVENT_HTTP_MESSAGE_RECEIVED, EVENT_PACKET_READ, EVENT_HTTP_CONTENT_LENGTH, EVENT_HTTP_CHUNKED_START, EVENT_HTTP_CHUNKED_END, EVENT_HTTP_CHUNKED_DATA_RECEIVED, EVENT_HTTP_CHUNK_SIZE, EVENT_HTTP_FOOTERS_RECEIVED, EVENT_HTTP_REDIRECT

Exceptions

  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the return value of the send() method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

hash Qore::HTTPClient::send | ( | string | body,
|  | string | method,
|  | *string | path,
|  | *hash | headers,
|  | softbool | getbody = `False`,
|  | *reference | info
| ) |  |

Sends an HTTP request with the specified method and optional message body and returns headers and any body received as a response in a hash format.

If a connection has not already been established, an internal call to HTTPClient::connect() will be made before sending the message

Example:
  my hash $msg = $httpclient.send($body, "POST", "/path", ("Content-Type":"application/x-yaml"));

Parameters

  body | The message body to send
  method | The name of the HTTP method (`"GET"`, `"POST"`, `"HEAD"`, `"OPTIONS"`, `"PUT"`, `"DELETE"`, `"TRACE"`, or `"CONNECT"`).
  path | The path for the message (i.e. `"/path/resource?method&param=value"`)
  headers | An optional hash of headers to include in the message.
  getbody | If this argument is True, then the object will try to receive a message body even if no `"Content-Length"` header is present in the response. Use this only with broken servers that send message bodies without a `"Content-Length"` header.
  info | An optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request.

Returns
  The headers received from the HTTP server with all key names converted to lower-case. The message body (if any) will be assigned to the value of the `"body"` key and the HTTP status will be assigned to the `"status_code"` key.

Exceptions

  HTTP-CLIENT-METHOD-ERROR | invalid/unknown HTTP method passed
  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the normal return value of this method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  ENCODING-CONVERSION-ERROR | the given string could not be converted to the socket's character encoding
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

hash Qore::HTTPClient::send | ( | *binary | body,
|  | string | method,
|  | *string | path,
|  | *hash | headers,
|  | softbool | getbody = `False`,
|  | *reference | info
| ) |  |

Sends an HTTP request with the specified method and optional message body and returns headers and any body received as a response in a hash format.

If a connection has not already been established, an internal call to HTTPClient::connect() will be made before sending the message

Example:
  my hash $msg = $httpclient.send($body, "POST", "/path", ("Content-Type":"application/x-yaml"));

Parameters

  body | The message body to send; pass NOTHING (no value) to send no body
  method | The name of the HTTP method (`"GET"`, `"POST"`, `"HEAD"`, `"OPTIONS"`, `"PUT"`, `"DELETE"`, `"TRACE"`, or `"CONNECT"`).
  path | The path for the message (i.e. `"/path/resource?method&param=value"`)
  headers | An optional hash of headers to include in the message.
  getbody | If this argument is True, then the object will try to receive a message body even if no `"Content-Length"` header is present in the response. Use this only with broken servers that send message bodies without a `"Content-Length"` header.
  info | An optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request.

Returns
  The headers received from the HTTP server with all key names converted to lower-case. The message body (if any) will be assigned to the value of the `"body"` key and the HTTP status will be assigned to the `"status_code"` key.

Exceptions

  HTTP-CLIENT-METHOD-ERROR | invalid/unknown HTTP method passed
  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the normal return value of this method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

nothing Qore::HTTPClient::sendWithCallbacks | ( | code | scb,
|  | code | rcb,
|  | string | method,
|  | *string | path,
|  | *hash | headers,
|  | timeout | timeout_ms = `0`,
|  | softbool | getbody = `False`,
|  | *reference | info
| ) |  |

Sends an HTTP request with the specified method and chunked message body as given by a send callback; headers and any body received are returned through a receive callback.

This method is useful for sending chunked message data where the response is also a sent with chunked transfer encoding; chunks are sent to the receive callback as soon as they are received. If a connection has not already been established, an internal call to HTTPClient::connect() will be made before sending the message

Example:
  my hash $msg = $httpclient.sendWithCallbacks($send_callback, $rcv_callback, "POST", "/path", ("Content-Type":"application/x-yaml"));

Parameters

  scb | The callback giving the chunked HTTP data to send; this callback must return either a string or a binary value each time it is called to give the chunked data to send; when all data has been sent, then a hash of message trailers can be sent or simply NOTHING which will close the chunked message
  rcb | The receive callback for the data received; first this method is called with a hash of the message headers, and then with any message body; if a chunked HTTP message is received, then the callback is called once for each chunk; when the message has been received, then the receive callback is called with a hash representing any trailer data received in a chunked transfer or NOTHING if the data was received in a normal message body or if there was no trailer data in a chunked transfer. The argument to this callback is always a hash; data calls have the following keys: `"data"`: the string or binary data `"chunked"`: True if the data was received with chunked transfer encoding, False if not Header or trailer data is placed in a hash with the following keys: `"hdr"`: this can be assigned to NOTHING for the trailer hash if the data was not sent chunked or no trailers were included in a chunked message `"obj"`: this is the owning object (so socket parameters can be changed based on headers received, such as, for example, socket character encoding) `"send_aborted"`: this is set to True if a response header was set while sending an outgoing chunked message
  method | The name of the HTTP method (`"GET"`, `"POST"`, `"HEAD"`, `"OPTIONS"`, `"PUT"`, `"DELETE"`, `"TRACE"`, or `"CONNECT"`).
  path | The path for the message (i.e. `"/path/resource?method&param=value"`)
  headers | An optional hash of headers to include in the message.
  timeout_ms | the timeout in milliseconds for the socket I/O operations; 0 means use the default timeout value
  getbody | If this argument is True, then the object will try to receive a message body even if no `"Content-Length"` header is present in the response. Use this only with broken servers that send message bodies without a `"Content-Length"` header.
  info | An optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request.

Exceptions

  HTTP-CLIENT-METHOD-ERROR | invalid/unknown HTTP method passed
  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the normal return value of this method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  ENCODING-CONVERSION-ERROR | the given string could not be converted to the socket's character encoding
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  - The `"Transfer-Encoding: chunked"` header is automatically set with this method if no `"Transfer-Encoding"` header is already present
  - if a response is received while the chunked send operation is still in progress, an error is assumed, the send operation is aborted, and the response header is read immediately and the `send_aborted` flag is set in the argument to rcb
  - For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

Since
  Qore 0.8.10

nothing Qore::HTTPClient::sendWithRecvCallback | ( | code | rcb,
|  | string | body,
|  | string | method,
|  | *string | path,
|  | *hash | headers,
|  | timeout | timeout_ms = `0`,
|  | softbool | getbody = `False`,
|  | *reference | info
| ) |  |

Sends an HTTP request with the specified method and optional message body; headers and any body received are returned through a receive callback.

This method is useful for receiving chunked message data in real time; chunks are sent to the receive callback as soon as they are received. If a connection has not already been established, an internal call to HTTPClient::connect() will be made before sending the message

Example:
  my hash $msg = $httpclient.sendWithRecvCallback($rcv_callback, $data, "POST", "/path", ("Content-Type":"application/x-yaml"));

Parameters

  rcb | The receive callback for the data received; first this method is called with a hash of the message headers, and then with any message body; if a chunked HTTP message is received, then the callback is called once for each chunk; when the message has been received, then the receive callback is called with a hash representing any trailer data received in a chunked transfer or NOTHING if the data was received in a normal message body or if there was no trailer data in a chunked transfer. The argument to this callback is always a hash; data calls have the following keys: `"data"`: the string or binary data `"chunked"`: True if the data was received with chunked transfer encoding, False if not Header or trailer data is placed in a hash with the following keys: `"hdr"`: this can be assigned to NOTHING for the trailer hash if the data was not sent chunked or no trailers were included in a chunked message `"obj"`: this is the owning object (so socket parameters can be changed based on headers received, such as, for example, socket character encoding)
  body | The message body to send
  method | The name of the HTTP method (`"GET"`, `"POST"`, `"HEAD"`, `"OPTIONS"`, `"PUT"`, `"DELETE"`, `"TRACE"`, or `"CONNECT"`).
  path | The path for the message (i.e. `"/path/resource?method&param=value"`)
  headers | An optional hash of headers to include in the message.
  timeout_ms | the timeout in milliseconds for the socket I/O operations; 0 means use the default timeout value
  getbody | If this argument is True, then the object will try to receive a message body even if no `"Content-Length"` header is present in the response. Use this only with broken servers that send message bodies without a `"Content-Length"` header.
  info | An optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request.

Exceptions

  HTTP-CLIENT-METHOD-ERROR | invalid/unknown HTTP method passed
  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the normal return value of this method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  ENCODING-CONVERSION-ERROR | the given string could not be converted to the socket's character encoding
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

Since
  Qore 0.8.10

nothing Qore::HTTPClient::sendWithRecvCallback | ( | code | rcb,
|  | *binary | body,
|  | string | method,
|  | *string | path,
|  | *hash | headers,
|  | timeout | timeout_ms = `0`,
|  | softbool | getbody = `False`,
|  | *reference | info
| ) |  |

Sends an HTTP request with the specified method and optional message body; headers and any body received are returned through a receive callback.

This method is useful for receiving chunked message data in real time; chunks are sent to the receive callback as soon as they are received. If a connection has not already been established, an internal call to HTTPClient::connect() will be made before sending the message

Example:
  my hash $msg = $httpclient.sendWithRecvCallback($rcv_callback, $data, "POST", "/path", ("Content-Type":"application/x-yaml"));

Parameters

  rcb | The receive callback for the data received; first this method is called with a hash of the message headers, and then with any message body; if a chunked HTTP message is received, then the callback is called once for each chunk; when the message has been received, then the receive callback is called with a hash representing any trailer data received in a chunked transfer or NOTHING if the data was received in a normal message body or if there was no trailer data in a chunked transfer. The argument to this callback is always a hash; data calls have the following keys: `"data"`: the string or binary data `"chunked"`: True if the data was received with chunked transfer encoding, False if not Header or trailer data is placed in a hash with the following keys: `"hdr"`: this can be assigned to NOTHING for the trailer hash if the data was not sent chunked or no trailers were included in a chunked message `"obj"`: this is the owning object (so socket parameters can be changed based on headers received, such as, for example, socket character encoding)
  body | The message body to send; pass NOTHING (no value) to send no body
  method | The name of the HTTP method (`"GET"`, `"POST"`, `"HEAD"`, `"OPTIONS"`, `"PUT"`, `"DELETE"`, `"TRACE"`, or `"CONNECT"`).
  path | The path for the message (i.e. `"/path/resource?method&param=value"`)
  headers | An optional hash of headers to include in the message.
  timeout_ms | the timeout in milliseconds for the socket I/O operations; 0 means use the default timeout value
  getbody | If this argument is True, then the object will try to receive a message body even if no `"Content-Length"` header is present in the response. Use this only with broken servers that send message bodies without a `"Content-Length"` header.
  info | An optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request.

Exceptions

  HTTP-CLIENT-METHOD-ERROR | invalid/unknown HTTP method passed
  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the normal return value of this method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  ENCODING-CONVERSION-ERROR | the given string could not be converted to the socket's character encoding
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

Since
  Qore 0.8.10

hash Qore::HTTPClient::sendWithSendCallback | ( | code | scb,
|  | string | method,
|  | *string | path,
|  | *hash | headers,
|  | timeout | timeout_ms = `0`,
|  | softbool | getbody = `False`,
|  | *reference | info
| ) |  |

Sends an HTTP request with the specified method and chunked message body as given by a send callback and returns headers and any body received as a response in a hash format.

If a connection has not already been established, an internal call to HTTPClient::connect() will be made before sending the message

Example:
  my hash $msg = $httpclient.sendWithSendCallback($callback, "POST", "/path", ("Content-Type":"application/x-yaml"));

Parameters

  scb | The callback giving the chunked HTTP data to send; this callback must return either a string or a binary value each time it is called to give the chunked data to send; when all data has been sent, then a hash of message trailers can be sent or simply NOTHING which will close the chunked message
  method | The name of the HTTP method (`"GET"`, `"POST"`, `"HEAD"`, `"OPTIONS"`, `"PUT"`, `"DELETE"`, `"TRACE"`, or `"CONNECT"`).
  path | The path for the message (i.e. `"/path/resource?method&param=value"`)
  headers | An optional hash of headers to include in the message.
  timeout_ms | the timeout in milliseconds for the socket I/O operations; 0 means use the default timeout value
  getbody | If this argument is True, then the object will try to receive a message body even if no `"Content-Length"` header is present in the response. Use this only with broken servers that send message bodies without a `"Content-Length"` header.
  info | An optional reference to an lvalue that will be used as an output variable giving a hash of request headers and other information about the HTTP request.

Returns
  The headers received from the HTTP server with all key names converted to lower-case. The message body (if any) will be assigned to the value of the `"body"` key and the HTTP status will be assigned to the `"status_code"` key.

Exceptions

  HTTP-CLIENT-METHOD-ERROR | invalid/unknown HTTP method passed
  HTTP-CLIENT-REDIRECT-ERROR | invalid redirect location given by remote
  HTTP-CLIENT-MAXIMUM-REDIRECTS-EXCEEDED | maximum redirect count exceeded
  HTTP-CLIENT-RECEIVE-ERROR | unknown content encoding received or status error communicating with HTTP server (status code < 100 or > 299); in case of a status error the `"arg"` key of the exception hash will be set to a hash equal to the normal return value of this method including a `"status_code"` key (giving the status code) and a `"body"` key (giving the message body returned by the server)
  ENCODING-CONVERSION-ERROR | the given string could not be converted to the socket's character encoding
  SOCKET-SEND-ERROR | There was an error sending the data
  SOCKET-CLOSED | The remote end closed the connection
  SOCKET-RECV-ERROR | There was an error receiving the data
  SOCKET-TIMEOUT | Data transmission or reception for a single send() or recv() action exceeded the timeout period
  SOCKET-SSL-ERROR | There was an SSL error while reading data from the socket
  SOCKET-HTTP-ERROR | Invalid HTTP data was received

Note
  - The `"Transfer-Encoding: chunked"` header is automatically set with this method if no `"Transfer-Encoding"` header is already present
  - For possible exceptions when implicitly establishing a connection, see the Socket::connect() method (or Socket::connectSSL() for secure connections)

Since
  Qore 0.8.10

nothing Qore::HTTPClient::setConnectTimeout | ( | timeout | timeout_ms = `-1` | ) |

Sets the connect timeout in milliseconds.

Parameters

  timeout_ms | the connect timeout in milliseconds; negative numbers mean use the default system connect timeout. Note that like all Qore functions and methods taking timeout values, a relative date/time value can be used to make the units clear (i.e. `30s` = 30 seconds, etc.).

Example:
  $httpclient.setConnectTimeout(2m);

nothing Qore::HTTPClient::setDefaultPath | ( | *string | path | ) |

Sets the default path used by the object if no path is set in the URL.

Parameters

  path | the default path value to set or if NOTHING then clears the path

Example:
  $httpclient.setDefaultPath();

nothing Qore::HTTPClient::setEncoding | ( | string | encoding | ) |

Sets the string encoding for the object; any strings deserialized with this object will be tagged with this character encoding.

Parameters

  encoding | the string encoding for the object; any strings deserialized with this object will be tagged with this character encoding

Example:
  $httpclient.setEncoding("UTF-8");

nothing Qore::HTTPClient::setEventQueue | ( |  | ) |

Clears any Queue object that may be set on the HTTPClient object so that I/O events are no longer captured on the object.

Example:
  $httpclient.setEventQueue();

nothing Qore::HTTPClient::setEventQueue | ( | Qore::Thread::Queue | queue | ) |

Sets a Queue object to receive HTTPClient and Socket events.

Parameters

  queue | a Queue object to receive HTTPClient and Socket events; note that the Queue passed cannot have any maximum size set or a QUEUE-ERROR will be thrown

Example:
  $httpclient.setEventQueue($queue);

Exceptions

  QUEUE-ERROR | the Queue passed has a maximum size set

See Also
  event_handling for more information

nothing Qore::HTTPClient::setHTTPVersion | ( | string | ver | ) |

Sets the HTTP protocol version string for headers in outgoing messages, allowed values are `"1.0"` and "1.1".

Parameters

  ver | `"1.0"` or "1.1" for the HTTP protocol compliance version

Example:
  $httpclient.setHTTPVersion("1.1");

Exceptions

  HTTP-VERSION-ERROR | invalid HTTP version passed (allowed values: `"1.0"` and "1.1")

nothing Qore::HTTPClient::setMaxRedirects | ( | softint | mr = `0` | ) |

Updates the setting for the `max_redirects` value for the object (maximum number of HTTP redirects that will be processed before an exception is raised)

Parameters

  mr | the setting for the maximum number of HTTP redirects that will be processed before an exception is raised

Example:
  $httpclient.setMaxRedirects(5);

See Also
  HTTPClient::getMaxRedirects() to retrieve this value

int Qore::HTTPClient::setNoDelay | ( | softbool | b = `True` | ) |

Sets the `TCP_NODELAY` setting for the object.

When this setting is True, then data will be immediately sent out over the HTTPClient object's socket, when it is False, then data transmission may be delayed to be packaged with other data for the same target.

Delayed data transmissions may cause problems when the sender immediately closes the socket after sending data; in this case the receiver may not get the data even though the send succeeded.

Note that if no value is given to the method, the argument will be assumed to be True, and output buffering will be turned off for the HTTPClient object.

If the socket is not connected when this call is made, then an internal flag is set and the `TCP_NODELAY` option is enabled when the next connection is established. If the socket is connected, then if an error occurs setting the `TCP_NODELAY` option on the socket, this method will return a non-zero error code; the actual error can be checked with the errno() function.

Example:
  $httpclient.setNoDelay(True);

Parameters

  b | the `TCP_NODELAY` setting for the object

See Also
  HTTPClient::getNoDelay()

Qore::HTTPClient::setPersistent | ( |  | ) |

temporarily disables implicit reconnections; must be called when the server is already connected

Example:
  $httpclient.connect();
  $httpclient.setPersistent();

The persistent flag is automatically reset to False whenever the connection is closed; it must be called manually for every connection to turn off implicit reconnections.

To turn off the persistent flag manually, call HTTPClient::disconnect()

Since
  Qore 0.8.10

nothing Qore::HTTPClient::setProxySecure | ( | softbool | b = `True` | ) |

Sets the SSL/TLS flag for the next connection to the proxy.

Example:
  $httpclient.setProxySecure(True);

See Also
  HTTPClient::isProxySecure() to check the flag

nothing Qore::HTTPClient::setProxyURL | ( |  | ) |

Clears the new proxy URL value for the next connection.

This variant of the method is equivalent to HTTPClient::clearProxyURL()

Example:
  $httpclient.setProxyURL();

nothing Qore::HTTPClient::setProxyURL | ( | string | url | ) |

Sets a new proxy URL value for the next connection.

Parameters

  url | the new proxy URL value for the next connection

Example:
  $httpclient.setProxyURL("http://user:password@proxy_host:8080/path");

Exceptions

  HTTP-CLIENT-URL-ERROR | invalid proxy URL string; invalid authorization credentials in proxy URL (username without password or vice-versa)
  HTTP-CLIENT-PROXY-PROTOCOL-ERROR | unknown protocol passed in URL

Note
  URLs with UNIX sockets are generally supported in Qore with the following syntax: `scheme://socket=<url_encoded_path>/path`, where `url_encoded_path` is a path with URL-encoding as performed by encode_url(); for example: `"http://socket=%2ftmp%socket-dir%2fsocket-file-1/url/path"`; this allows a filesystem path to be used in the host portion of the URL and for the URL to include a URL path as well.

nothing Qore::HTTPClient::setProxyUserPassword | ( | string | user,
|  | string | pass
| ) |  |

Sets the username and password for the connection to the proxy; call after HTTPClient::setProxyURL()

Call this method after calling HTTPClient::setProxyURL() to set proxy authentication information when not present in the URL used in HTTPClient::setProxyURL()

Example:
  $httpclient.setProxyUserPassword($user, $pass);

Parameters

  user | the username to use for proxy authentication in the next HTTP connection
  pass | the password to use for proxy authentication in the next HTTP connection

nothing Qore::HTTPClient::setProxyUserPassword | ( |  | ) |

Clears the username and password for the next proxy connection.

Call this method after calling HTTPClient::setProxyURL() to clear any proxy authentication information present in the URL used in HTTPClient::setProxyURL()

This variant of the method is equivalent to HTTPClient::clearProxyUserPassword()

Example:
  $httpclient.setProxyUserPassword();

See Also
  HTTPClient::clearProxyUserPassword()

nothing Qore::HTTPClient::setSecure | ( | softbool | secure = `True` | ) |

Sets the object to make a secure SSL/TLS connection on the next connect if the passed argument is True, or an unencrypted cleartext connection if it is False.

This method overrides the default behaviour for the protocol set for the object

Note that the behavior of this method when called with no argument changed in version 0.8.0; prior to version 0.8.0 calling this method with no argument would turn off secure mode; the behavior was changed to the current functionality in order to make the usage of this method consistent with other methods of the same name and to make it more logical.

Example:
  $httpclient.setSecure(True);

Parameters

  secure | if True, a SSL/TLS connection will be attempted on the next connection. If False, an unencrypted cleartext connection will be established

nothing Qore::HTTPClient::setTimeout | ( | timeout | timeout_ms = `0` | ) |

Sets the default I/O timeout value in milliseconds.

Parameters

  timeout_ms | 0 means immediate timeout (when reading will return data only if it is already available), and negative numbers mean never timeout. Note that like all Qore functions and methods taking timeout values, a relative date/time value can be used to make the units clear (i.e. `2m` = two minutes, etc.).

Example:
  $httpclient.setTimeout(2m);

Qore::HTTPClient::setURL | ( | string | url | ) |

Sets a new URL value for the next connection.

To retrieve the current URL value, use the HTTPClient::getURL() method

Example:
  $httpclient.setURL("https://user:password@hostname:8080/path");

Parameters

  url | the new URL for the object

Exceptions

  HTTP-CLIENT-URL-ERROR | invalid URL string; invalid authorization credentials in URL (username without password or vice-versa)
  HTTP-CLIENT-UNKNOWN-PROTOCOL | unknown protocol (scheme) passed in URL

See Also
  HTTPClient::getURL()

Note
  URLs with UNIX sockets are generally supported in Qore with the following syntax: `scheme://socket=<url_encoded_path>/path`, where `url_encoded_path` is a path with URL-encoding as performed by encode_url(); for example: `"http://socket=%2ftmp%socket-dir%2fsocket-file-1/url/path"`; this allows a filesystem path to be used in the host portion of the URL and for the URL to include a URL path as well.

nothing Qore::HTTPClient::setUserPassword | ( | string | user,
|  | string | pass
| ) |  |

Sets the username and password for the connection; call after HTTPClient::setURL()

Call this method after calling HTTPClient::setURL() to set authentication information when not present in the URL used in HTTPClient::setURL()

Parameters

  user | the username to use for authentication in the next HTTP connection
  pass | the password to use for authentication in the next HTTP connection

Example:
  $httpclient.setUserPassword($user, $pass);

nothing Qore::HTTPClient::setUserPassword | ( |  | ) |

Clears the username and password for the connection.

Call this method after calling HTTPClient::setURL() to clear any authentication information present in the URL used in HTTPClient::setURL()

This variant of the method is equivalent to HTTPClient::clearUserPassword()

Example:
  $httpclient.setUserPassword();

See Also
  HTTPClient::clearUserPassword()

nothing Qore::HTTPClient::setWarningQueue | ( | int | warning_ms,
|  | int | warning_bs,
|  | Queue | queue,
|  | any | arg,
|  | timeout | min_ms = `1s`
| ) |  |

Sets a Queue object to receive socket warnings.

Example:
  $httpclient.setWarningQueue(5000, 5000, $queue, "socket-1");

Parameters

  warning_ms | the threshold in milliseconds for individual socket actions (send, receive, connect), if exceeded, a socket warning is placed on the warning queue with the following keys: `"type"`: a string with the constant value `"SOCKET-OPERATION-WARNING"` `"operation"`: a string giving the operation that caused the warning (ex: `"connect"`) `"us"`: an integer giving the number of microseconds for the operation `"timeout"`: an integer giving the warning threshold in microseconds `"arg"`: if any `"arg"` argument is passed to the HTTPClient::setWarningQueue() method, it will be included in the warning hash here
  warning_bs | value in bytes per second; if any call has performance below this threshold, a socket warning is placed on the warning queue with the following keys: `"type"`: a string with the constant value `"SOCKET-THROUGHPUT-WARNING"` `"dir"`: either `"send"` or `"recv"` depending on the direction of the data flow `"bytes"`: the amount of bytes sent `"us"`: an integer giving the number of microseconds for the operation `"bytes_sec"`: a float giving the transfer speed in bytes per second `"threshold"`: an integer giving the warning threshold in bytes per second `"arg"`: if any `"arg"` argument is passed to the HTTPClient::setWarningQueue() method, it will be included in the warning hash here
  queue | the Queue object to receive warning events
  arg | an optional argument to be placed in the `"arg"` key in each warning hash (could be used to identify the socket for example)
  min_ms | the minimum transfer time with a resolution of milliseconds for a transfer to be eligible for triggering a warning; transfers that take less than this period of time are not eligible for raising a warning

Exceptions

  QUEUE-ERROR | the Queue passed has a maximum size set
  SOCKET-SETWARNINGQUEUE-ERROR | at least one of warning_ms and warning_bs must be > 0

See Also
  HTTPClient::clearWarningQueue()

Since
  Qore 0.8.9